
/*
    $File$
    Date        Author          Changes
    Nov 21 2000 Richard Jones   Created

    Copyright (c) 2000, Richard Jones
    All rights reserved.
 */

 
package MetaTF.Parser;


/**
 * Abstract syntax tree node representing default <number>
 *
 * @see <a href="metatf.jjt">The MetaTF Grammar</a>
 * @version rel-1-2 ($Revision: 1.3 $, $Date: 2000/12/15 16:29:55 $),
 * @author Richard Jones
**/
public class Default extends Value {
  private static final String cvsheader = "$Header: /home/cur/rej/cvs/MetaTF/src/MetaTF/Parser/Default.java,v 1.3 2000/12/15 16:29:55 rej Exp $";

    /** the default **/
	private Integer value;

	/**
	 * ALlocate an object representing the default
	 * @param d the default
	**/
	Default(int d) { value = new Integer(d); }

    /** @return the default value **/
	public int getDefault() { return value.intValue(); }

    /**
     * Set the default value
     * @param d the default
    **/
	void setDefault(int d) {value = new Integer(d); }

	public String toString() {
	    return "default " + value.toString();
	}

	public String dump(String prefix) { return "default "+value.intValue(); }

    public Object accept(DTDVisitor visitor, Object data) {
        return visitor.visit(this, data);
    }
}
