/*
    $File$
    Date        Author          Changes
    Nov 21 2000 Richard Jones   Created

    Copyright (c) 2000, Richard Jones
    All rights reserved.
 */

 
package MetaTF.Parser;


/**
 * Abstract syntax tree node representing delta <number>
 *
 * @see <a href="metatf.jjt">The MetaTF Grammar</a>
 * @see MetaTF.Parser.Value
 * @version rel-1-2 ($Revision: 1.3 $, $Date: 2000/12/15 16:29:55 $),
 * @author Richard Jones
**/
public class Delta extends Value {
  private static final String cvsheader = "$Header: /home/cur/rej/cvs/MetaTF/src/MetaTF/Parser/Delta.java,v 1.3 2000/12/15 16:29:55 rej Exp $";

    /** the initial value **/
	private Integer initialValue;

	/**
	 * Allocate an object representing delta <initial value>
	 * @param d the initial value
	**/
	Delta(int d) { initialValue = new Integer(d); }

    /** @return the initial value **/
	public int getDelta() { return initialValue.intValue(); }

	/**
	 * Set the initial value
	 * @param the initial value
	**/
	void setDelta(int d) {initialValue = new Integer(d); }

	public String toString() {
	    return "delta "+initialValue;
	}

	public String dump(String prefix) {
	    return "delta "+initialValue;
	}

    public Object accept(DTDVisitor visitor, Object data) {
        return visitor.visit(this, data);
    }
}
