/* Generated By:JavaCC: Do not edit this line. Token.java Version 0.7pre3 */
/**
 *
 * Copyright (C) 2000 Richard Jones.
 *
 * Grammar for MetaTF 1.2
 *
 * Based on Grammar for Meta-TF 1.0, for which details can be found in
 * "Designing a Trace Format for Heap Allocation Events",
 * Trishul Chilimbi, Richard Jones and Benjamin Zorn,
 * ISMM 2000, Minneapolis, October 2000, ACM.
 *
 * Changes since MetaTF 1.0:
 *
 * MetaTF 1.2
 * 1. Record fields are typed. The primitive types are:
 *     byte, short, int, long, string or index.
 * 2. Only the following encodings are recognised:
 *    None, Delta, Default, BaseOffset and Stride.
 *    Strings may only have encodings None or Default.
 * 3. The syntax for defining fields is changed. For example,
 *        int foo = Default 3;
 * 4. Only single line comments starting with a # are allowed.
 *
 * MetaTF 1.1
 * 1. Removed RHS of property in the form "field.property"
 * 2. Removed anonymous tuples, e.g. rec : (a, b, (x, y), c)
 *    These must now be written as either
 *	rec : (a, b, x, y, z)
 *    or
 *	xy : (x, y)
 *	rec: (a, b, xy, c)
 * 3. In repeated events, such as a * b, clarify that
 *    a is a new field, not a reference to an existing one.
 */

// $Header: /home/cur/rej/cvs/MetaTF/src/MetaTF/Parser/Token.java,v 1.4 2001/03/29 15:53:18 rej Exp $

package MetaTF.Parser;

/**
 * Describes the input token stream.
 */

public class Token {

  /**
   * An integer that describes the kind of this token.  This numbering
   * system is determined by JavaCCParser, and a table of these numbers is
   * stored in the file ...Constants.java.
   */
  public int kind;

  /**
   * beginLine and beginColumn describe the position of the first character
   * of this token; endLine and endColumn describe the position of the
   * last character of this token.
   */
  public int beginLine, beginColumn, endLine, endColumn;

  /**
   * The string image of the token.
   */
  public String image;

  /**
   * A reference to the next regular (non-special) token from the input
   * stream.  If this is the last token from the input stream, or if the
   * token manager has not read tokens beyond this one, this field is
   * set to null.  This is true only if this token is also a regular
   * token.  Otherwise, see below for a description of the contents of
   * this field.
   */
  public Token next;

  /**
   * This field is used to access special tokens that occur prior to this
   * token, but after the immediately preceding regular (non-special) token.
   * If there are no such special tokens, this field is set to null.
   * When there are more than one such special token, this field refers
   * to the last of these special tokens, which in turn refers to the next
   * previous special token through its specialToken field, and so on
   * until the first special token (whose specialToken field is null).
   * The next fields of special tokens refer to other special tokens that
   * immediately follow it (without an intervening regular token).  If there
   * is no such token, this field is null.
   */
  public Token specialToken;

  /**
   * Returns the image.
   */
  public final String toString()
  {
     return image;
  }

  /**
   * Returns a new Token object, by default. However, if you want, you
   * can create and return subclass objects based on the value of ofKind.
   * Simply add the cases to the switch for all those special cases.
   * For example, if you have a subclass of Token called IDToken that
   * you want to create if ofKind is ID, simlpy add something like :
   *
   *    case MyParserConstants.ID : return new IDToken();
   *
   * to the following switch statement. Then you can cast matchedToken
   * variable to the appropriate type and use it in your lexical actions.
   */
  public static final Token newToken(int ofKind)
  {
     switch(ofKind)
     {
       default : return new Token();
     }
  }

}
