
/*
    $File$
    Date        Author          Changes
    Nov 21 2000 Richard Jones   Created

    Copyright (c) 2000, Richard Jones
    All rights reserved.
 */

 
package MetaTF.Parser;


/**
 * Abstract base class for values
 *
 * @see <a href="metatf.jjt">The MetaTF Grammar</a>
 * @see MetaTF.Parser.None
 * @see MetaTF.Parser.Default
 * @see MetaTF.Parser.StringDefault
 * @see MetaTF.Parser.Delta
 * @see MetaTF.Parser.SectionOffset
 * @see MetaTF.Parser.SectionStride
 * @see MetaTF.Parser.Stride
 * @see MetaTF.Parser.NumberValue
 * @version rel-1-2 ($Revision: 1.3 $, $Date: 2000/12/15 16:29:55 $),
 * @author Richard Jones
**/
public abstract class Value {
  private static final String cvsheader = "$Header: /home/cur/rej/cvs/MetaTF/src/MetaTF/Parser/Value.java,v 1.3 2000/12/15 16:29:55 rej Exp $";

    Value() {}

    /** @return a string representation of this object **/
    public abstract String toString();
    
    /** @return a prettified representation of this object **/
    public abstract String dump(String prefix);

    /** Accept the visitor **/
    public abstract Object accept(DTDVisitor visitor, Object data);
}
