/*
    $File$
    Date        Author          Changes
    Nov 20 2000 Richard Jones   Created
    Nov 21 2000 Richard Jones   Changed import structure
    
    Copyright (c) 2000, Richard Jones
    All rights reserved.
 */
 
package MetaTF.Runtime;

import java.io.*;

/**
 * AsciiWriter implements LowLevelWriter
 *
 * @version rel-1-2 ($Revision: 1.1 $, $Date: 2000/12/15 16:35:32 $),
 * @author Richard Jones
**/
public class AsciiWriter implements LowLevelWriter {

    private PrintStream wtr;

    public AsciiWriter(OutputStream os) {
    	wtr = (PrintStream)os;
    }

    public void write(long value) throws IOException {
        if(value<0)
            wtr.print("-"+Long.toHexString(-value)+" ");
        else
            wtr.print(Long.toHexString(value)+" ");
    }

    public void write(int value) throws IOException {
        if(value<0)
            wtr.print("-"+Integer.toHexString(-value)+" ");
        else
            wtr.print(Integer.toHexString(value)+" ");
    }

    public void write(char value) throws IOException {
        wtr.print(value+" ");
    }

    public void write(String value) throws IOException {
        StringBuffer buf = new StringBuffer("\"");
        for(int i=0; i<value.length(); i++) {
            char c = value.charAt(i);
            switch(c) {
             case '\n':  buf.append("\\n"); break;
             case '\t':  buf.append("\\t"); break;
             case '\b':  buf.append("\\b"); break;
             case '\r':  buf.append("\\r"); break;
             case '\f':  buf.append("\\f"); break;
             case '\\':  buf.append("\\\\"); break;
             case '\'':  buf.append("\'");   break;
             case '\"':  buf.append("\\\""); break;                    	
             default: // Should really deal with other funny characters better
                 buf.append(c);
                 break;
            }
        }
        wtr.print(buf.append("\""+" "));
    }

    public void writeln(String s) {
        wtr.println(s);
    }
    
    public void writeln() throws IOException {
        wtr.println();
    }

    public void close() { wtr.close(); }

    public void flush() { wtr.flush(); }
}
