/*
    $File$
    Date        Author          Changes
    Nov 30 2000 Richard Jones   Created
    
    Copyright (c) 2000, Richard Jones
    All rights reserved.
 */
 
package MetaTF.Runtime;

import java.util.List;

/**
 * This class represents a section of the DTD.
 * It holds an array of records defined in the section, indexed by their tag.
 * If the section is cached, a reference to the cache is held here
 *
 * @version rel-1-2 ($Revision: 1.1 $, $Date: 2000/12/15 16:35:32 $),
 * @author Richard Jones
**/
class TraceSection {                                                         

    /** The array of TraceRecords, indexed by record tag **/
    TraceRecord[] records;                                                   

    /**
     * Allocate a new object representing a section of the DTD
     * @param n the value of the largest tag in this section (hence the number of
     *          TraceRecords to allocate
    **/
    TraceSection(int n) {                                            
        records = new TraceRecord[n];                                        
    }                                                                        
}                                                                            

